<?php
/**
 * @copyright	  Copyright © 2015 - All rights reserved.
 * @license      GNU General Public License version 2 or later; see LICENSE
 * @author       Planet Web GmbH
 * @author mail  rene.kurt@planet-web.ch
 * @website      http://www.planet-web.ch
 *
 * 14.08.2015 Extended the funcionality to show a decription to each picture by adding a .txt file with same name as the picture in base directory
 *
 * 10.03.2018 Error eliminated if thumbs directory already exists. Error eliminated for PNG thumbs creation, quality paramater was wrong
 *
 * This plugin is an extension of
 * ------------------------------
 * @author		Joompolitan
 * @author mail	james.liu668@gmail.com
 * @website		http://www.joompolitan.com/
 */
 
/**
 * The original has been extended to generate thumbnails
 * and have the thumbnails always in square format.
 *
 * Now the load time if you have a bigger gallery is much
 * faster than the original
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class plgContentPWGallery extends JPlugin
{
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
	}

	function onContentPrepare( $context, &$row, &$params, $page=0 )
	{
		$app = JFactory::getApplication();
        // Plugin code goes here.
        // You can access parameters via $this->params.
		
		// expression to search for
		$regex = "#{pwgallery(.*?)}(.*?){/pwgallery}#s";

		// find all instances of plugin and put in $matches
		$matches = array();
		preg_match_all( $regex, $row->text, $matches, PREG_SET_ORDER );
		$num = sizeof($matches);

		for ($i = 0; $i < $num; $i++) { 
			$galleryHTML = $this->generateGallery( $this->params, $matches[$i], $i );
			$row->text = preg_replace("{".$matches[$i][0]."}", $galleryHTML , $row->text, 1);
		}
		
		if($num > 0)
		{
			$currentURL = $this->params->def('websiteBaseURL');
			if ($currentURL == ''){
				if( isset($_SERVER['HTTPS'] ) ) {
					$currentURL = 'https://'.$_SERVER['HTTP_HOST'];
				}
				else {
					$currentURL = 'http://'.$_SERVER['HTTP_HOST'];
				}
 			}
			
			$currentURL = $currentURL . '/plugins/content/pwgallery/';
			
			$galleryJS = "";
			if($this->params->def('embedjQuery') == 1) {
				$galleryJS .= "<script src=\"".$currentURL."js/jquery-1.11.0.min.js\"></script>";
			}
			$galleryJS .= "<script src=\"".$currentURL."js/lightbox.min.js\"></script>";
			$galleryJS .= "<link href=\"".$currentURL."css/lightbox.css\" rel=\"stylesheet\" />";
			$row->text .= $galleryJS;
			
			$anchorTextArray = array(
				"<a style=\"font-size: 8px !important;text-decoration: none  !important; color: #E0E0E0  !important;\" href=\"http://www.joompolitan.com/lightgallery.html\" title\"Free Joomla Lightbox Gallery\">Free Joomla Lightbox Gallery</a>", 
				"<a style=\"font-size: 8px !important;text-decoration: none  !important; color: #E0E0E0  !important;\" href=\"http://www.joompolitan.com/lightgallery.html\" title\"Free Lightbox Gallery\">Free Lightbox Gallery</a>",
				"<a style=\"font-size: 8px !important;text-decoration: none  !important; color: #E0E0E0  !important;\" href=\"http://www.joompolitan.com/\" title\"Joomla Plugins\">Joomla Plugins</a>",
				"<a style=\"font-size: 8px !important;text-decoration: none  !important; color: #E0E0E0  !important;\" href=\"http://www.joompolitan.com/\" title\"Joomla Extensions\">Joomla Extensions</a>",
				"<a style=\"font-size: 8px !important;text-decoration: none  !important; color: #E0E0E0  !important;\" href=\"http://www.joompolitan.com/products.html\" title\"More Joomla Extensions\">More Joomla Extensions</a>");
				
			//$row->text .= $anchorTextArray[$currentURL%5];
		}
		
		return true;
	}
	
	private function generateGallery( $params, $options ) {
		$options[1] = str_replace (" ", "&", $options[1]); //replace space with &
		parse_str($options[1], $OptionArray);
		
		//gallery attribute
		$urlstr = array();
		if(empty($OptionArray['type']))
		{
			return "<strong>PW Gallery format is incorrect, type is missing!</strong>";
		}
		else if(empty($OptionArray['path']))
		{
			return "<strong>PW Gallery format is incorrect, path is missing!</strong>";
		}
		
		
		if(empty($OptionArray['previewWidth']))
		{
			$OptionArray['previewWidth'] = "";
		}
		
		if(empty($OptionArray['previewHeight']))
		{
			$OptionArray['previewHeight'] = "";
		}

		if(empty($OptionArray['galleryName']))
		{
			$OptionArray['galleryName'] = "PW Gallery";
		}

		if(empty($OptionArray['thumbSize']))
		{
			$OptionArray['thumbSize'] = 200;
		}

		if(!empty($OptionArray['enabled']) && $OptionArray['enabled'] === "false")
		{
			return str_replace ("enabled=false ", "", $options[0]); //remove this flag and config show string
		}

		switch($OptionArray['type'])
		{
			case "url":
				$urlstr[] = trim($OptionArray['path']);
				break;
			case "local":
				$path = trim($OptionArray['path']);
				if(file_exists($path))
				{
					$currentURL = $params->def('websiteBaseURL');
					if ($currentURL == ''){
						if( isset($_SERVER['HTTPS'] ) ) {
							$currentURL = 'https://'.$_SERVER['HTTP_HOST'];
						}
						else {
							$currentURL = 'http://'.$_SERVER['HTTP_HOST'];
						}
					}
					
					if(is_dir($path))
					{
						// build the thumbnails if parameter is set
						// in the parameter we need createthumb=true thumbSize=x (default 200)
						// when thumbnails are created set parameter to createthumb=false
						if($OptionArray['createthumb'] == "true") {
							// create the folder if it not exists
							if(! file_exists($path . "/thumbs")) {
								mkdir($path . "/thumbs");
							}
							// now create the thumbs
							$new_height = $OptionArray['thumbSize'];
							$new_width = $OptionArray['thumbSize'];
							$files = scandir($path);
							$imageExt = array("png", "jpg", "jpeg", "gif");
							foreach($files as $file)
							{
								if(!is_dir($file))
								{
									$file_extension =  pathinfo($file, PATHINFO_EXTENSION);
									if(in_array(strtolower($file_extension), $imageExt))
									{
										// now convert the image to square format
										$image_new = imagecreatetruecolor($new_width, $new_height);
										switch(strtolower($file_extension)) {
											case "png":
												$image_old = imagecreatefrompng($path . "/" . $file);
												break;
											case "jpg":
											case "jpeg":
												$image_old = imagecreatefromjpeg($path . "/" . $file);
												break;
											case "gif":
												$image_old = imagecreatefromgif($path . "/" . $file);
												break;
										}
										list($old_width, $old_height) = getimagesize($path . "/" . $file);
									
										// Setzen von Offset im Originalbild
										if($old_width > $old_height) {
											// Bild im Landscape Format
											$x_offset = ($old_width - $old_height) / 2;
											$y_offset = 0;
											$src_width = $old_height;
											$src_height = $old_height;
										}
										else {
											// Bild im Portrait Format
											$x_offset = 0;
											$y_offset = ($old_height - $old_width) / 2;
											$src_width = $old_width;
											$src_height = $old_width;
										}
										
										imagecopyresampled($image_new, $image_old, 0, 0, $x_offset, $y_offset, $new_width, $new_height, $src_width, $src_height);
									
										// Output
										switch(strtolower($file_extension)) {
											case "png":
												imagepng($image_new, $path . "/thumbs/" . $file, 9);
												break;
											case "jpg":
											case "jpeg":
												imagejpeg($image_new, $path . "/thumbs/" . $file, 100);
												break;
											case "gif":
												imagegif($image_new, $path . "/thumbs/" . $file);
												break;
										}
									}
								}
							}
						}
						//loop the path and build image url
						$files = scandir($path);
						$imageExt = array("png", "jpg", "jpeg", "gif");
						foreach($files as $file)
						{
							if(!is_dir($file))
							{
								$file_extension =  pathinfo($file, PATHINFO_EXTENSION);
								if(in_array(strtolower($file_extension), $imageExt))
								{
									$urlstr[] = $currentURL."/".$path."/".$file;
									$thumbstr[] = $currentURL."/".$path."/thumbs/".$file;
								}
							}
						}
					}
					else
					{
						$urlstr[] = $currentURL.$path;
					}
				}
				else
				{
					return "<strong>PW Gallery cannot find your image path: <i>$path</i>!</strong>";
				}
				
				break;
			default:
				return $OptionArray['type']."<strong>PW Gallery Format is incorrect, path is missing!</strong>";
		}
		
		//find parameter
		$margin = "20";
		$awidth = $margin + $OptionArray['previewWidth'];
		$galleryText = "";
		foreach($urlstr as $k=>$v)
		{
//echo $k . " => " . $v . "<br>";
			if($OptionArray['type'] == "local") {
				// Check if there is a .txt file which contains a description to the picture
				$path_parts = pathinfo($v);
				if (file_exists($path . "/" . $path_parts["filename"] . ".txt")) {
					$comment = file_get_contents($path . "/" . $path_parts["filename"] . ".txt");
				}
				else {
					$comment = "&nbsp;";
				}
				$galleryText .= "<a href=\"".$v."\" data-lightbox=\"".$OptionArray['galleryName']."\" data-title=\"".$options[2]."\" style=\"display:inline-block;width:" . $awidth . "px;vertical-align:top;margin-right:" . $margin . "px\" title=\"" . $comment . "\">"."<img src=\"".$thumbstr[$k]."\" style=\"margin-right: ".$margin."px; width: ".$OptionArray['previewWidth']."px; height: ".$OptionArray['previewHeight']."px;\">";
				$galleryText .= "<br><span style=\"margin-right:" . $margin . "px;\">" . $comment . "</span></a>";
			}
			else {
				$galleryText .= "<a href=\"".$v."\" data-lightbox=\"".$OptionArray['galleryName']."\" data-title=\"".$options[2]."\">"."<img src=\"".$v."\" style=\"margin: ".$margin."; width: ".$OptionArray['previewWidth']."px; height: ".$OptionArray['previewHeight']."px;\">"."</a>";
			}
		}
		return $galleryText;
	}
}
?>
